diff --git a/apps/web/src/components/resume/use-resume.ts b/apps/web/src/components/resume/builder-resume-draft.ts
similarity index 61%
rename from apps/web/src/components/resume/use-resume.ts
rename to apps/web/src/components/resume/builder-resume-draft.ts
index 42ae89720..b9b90b5d9 100644
--- a/apps/web/src/components/resume/use-resume.ts
+++ b/apps/web/src/components/resume/builder-resume-draft.ts
@@ -2,13 +2,11 @@ import type { ResumeData } from "@reactive-resume/schema/resume/data";
 import type { QueryClient, QueryKey } from "@tanstack/react-query";
 import type { WritableDraft } from "immer";
 import { t } from "@lingui/core/macro";
-import { useQuery, useQueryClient } from "@tanstack/react-query";
+import { useQueryClient } from "@tanstack/react-query";
 import { useParams } from "@tanstack/react-router";
 import { debounce } from "es-toolkit";
-import isDeepEqual from "fast-deep-equal";
 import { useCallback, useEffect } from "react";
 import { toast } from "sonner";
-import { temporal } from "zundo";
 import { immer } from "zustand/middleware/immer";
 import { create } from "zustand/react";
 import { orpc } from "@/libs/orpc/client";
@@ -40,8 +38,6 @@ type ResumeStoreActions = {
 
 type ResumeStore = ResumeStoreState & ResumeStoreActions;
 
-type PartializedState = { data: ResumeData | null };
-
 type Runtime = {
 	abortController: AbortController;
 	queryClient?: QueryClient;
@@ -50,8 +46,6 @@ type Runtime = {
 	beforeUnloadHandler?: () => void;
 };
 
-const HISTORY_LIMIT = 100;
-const GROUPED_HISTORY_MS = 250;
 const SAVE_DEBOUNCE_MS = 500;
 const runtimes = new Map<string, Runtime>();
 
@@ -141,81 +135,66 @@ function syncCurrentResume(id: string) {
 }
 
 export const useResumeStore = create<ResumeStore>()(
-	temporal(
-		immer((set, get) => ({
-			resume: null,
-			resumeId: undefined,
-			isReady: false,
+	immer((set, get) => ({
+		resume: null,
+		resumeId: undefined,
+		isReady: false,
 
-			initialize: (resume) => {
-				set((state) => {
-					state.resume = resume;
-					state.resumeId = resume?.id;
-					state.isReady = resume !== null;
-				});
-
-				useResumeStore.temporal.getState().clear();
-			},
-
-			reset: () => {
-				set((state) => {
-					state.resume = null;
-					state.resumeId = undefined;
-					state.isReady = false;
-				});
-
-				useResumeStore.temporal.getState().clear();
-			},
-
-			patchResume: (fn) => {
-				set((state) => {
-					if (!state.resume) return;
-					fn(state.resume as WritableDraft<Resume>);
-				});
-			},
-
-			mergeResumeMetadata: (resume) => {
-				set((state) => {
-					if (!state.resume || state.resume.id !== resume.id) return;
-
-					state.resume.name = resume.name;
-					state.resume.slug = resume.slug;
-					state.resume.tags = resume.tags;
-					state.resume.isLocked = resume.isLocked;
-					state.resume.hasPassword = resume.hasPassword;
-					state.resume.isPublic = resume.isPublic;
-				});
-			},
-
-			updateResumeData: (fn) => {
-				const currentResume = get().resume;
-				if (!currentResume) return;
-
-				if (currentResume.isLocked) {
-					lockedToastId = toast.error(t`This resume is locked and cannot be updated.`, {
-						id: lockedToastId,
-					});
-					return;
-				}
-
-				set((state) => {
-					if (!state.resume) return;
-					fn(state.resume.data as WritableDraft<ResumeData>);
-				});
-
-				syncCurrentResume(currentResume.id);
-			},
-		})),
-		{
-			partialize: (state): PartializedState => ({ data: state.resume?.data ?? null }),
-			equality: (pastState, currentState) => isDeepEqual(pastState, currentState),
-			limit: HISTORY_LIMIT,
-			handleSet: (handleSet) =>
-				debounce((state: Parameters<typeof handleSet>[0], replace?: Parameters<typeof handleSet>[1]) => {
-					handleSet(state as never, replace as never);
-				}, GROUPED_HISTORY_MS) as typeof handleSet,
+		initialize: (resume) => {
+			set((state) => {
+				state.resume = resume;
+				state.resumeId = resume?.id;
+				state.isReady = resume !== null;
+			});
 		},
-	),
+
+		reset: () => {
+			set((state) => {
+				state.resume = null;
+				state.resumeId = undefined;
+				state.isReady = false;
+			});
+		},
+
+		patchResume: (fn) => {
+			set((state) => {
+				if (!state.resume) return;
+				fn(state.resume as WritableDraft<Resume>);
+			});
+		},
+
+		mergeResumeMetadata: (resume) => {
+			set((state) => {
+				if (!state.resume || state.resume.id !== resume.id) return;
+
+				state.resume.name = resume.name;
+				state.resume.slug = resume.slug;
+				state.resume.tags = resume.tags;
+				state.resume.isLocked = resume.isLocked;
+				state.resume.hasPassword = resume.hasPassword;
+				state.resume.isPublic = resume.isPublic;
+			});
+		},
+
+		updateResumeData: (fn) => {
+			const currentResume = get().resume;
+			if (!currentResume) return;
+
+			if (currentResume.isLocked) {
+				lockedToastId = toast.error(t`This resume is locked and cannot be updated.`, {
+					id: lockedToastId,
+				});
+				return;
+			}
+
+			set((state) => {
+				if (!state.resume) return;
+				fn(state.resume.data as WritableDraft<ResumeData>);
+			});
+
+			syncCurrentResume(currentResume.id);
+		},
+	})),
 );
 
 export function useInitializeResumeStore() {
@@ -250,36 +229,8 @@ export function useCurrentBuilderResumeSelector<T>(selector: (resume: Resume) =>
 	return selected;
 }
 
-/**
- * Reads the resume from the builder store when editing, and from query cache
- * for non-builder/public routes.
- */
 export function useResume(): Resume | undefined {
-	const params = useParams({ strict: false }) as {
-		resumeId?: string;
-		username?: string;
-		slug?: string;
-	};
-
-	const builderResume = useResumeStore((state) => {
-		if (!params.resumeId || !state.resume || state.resume.id !== params.resumeId) return undefined;
-		return state.resume;
-	});
-
-	const byIdQuery = useQuery({
-		...orpc.resume.getById.queryOptions({ input: { id: params.resumeId ?? "" } }),
-		enabled: !!params.resumeId,
-	});
-
-	const bySlugQuery = useQuery({
-		...orpc.resume.getBySlug.queryOptions({
-			input: { username: params.username ?? "", slug: params.slug ?? "" },
-		}),
-		enabled: !!(!params.resumeId && params.username && params.slug),
-	});
-
-	if (params.resumeId) return builderResume ?? (byIdQuery.data as Resume | undefined);
-	return bySlugQuery.data as Resume | undefined;
+	return useBuilderResumeSelector((resume) => resume);
 }
 
 export function useCurrentResume(): Resume {
@@ -289,23 +240,7 @@ export function useCurrentResume(): Resume {
 }
 
 export function useResumeData(): ResumeData | undefined {
-	const params = useParams({ strict: false }) as { resumeId?: string; username?: string; slug?: string };
-	const builderData = useBuilderResumeSelector((resume) => resume.data);
-
-	const byIdQuery = useQuery({
-		...orpc.resume.getById.queryOptions({ input: { id: params.resumeId ?? "" } }),
-		enabled: !!params.resumeId,
-	});
-
-	const bySlugQuery = useQuery({
-		...orpc.resume.getBySlug.queryOptions({
-			input: { username: params.username ?? "", slug: params.slug ?? "" },
-		}),
-		enabled: !!(!params.resumeId && params.username && params.slug),
-	});
-
-	if (params.resumeId) return builderData ?? (byIdQuery.data as Resume | undefined)?.data;
-	return (bySlugQuery.data as Resume | undefined)?.data;
+	return useBuilderResumeSelector((resume) => resume.data);
 }
 
 export function useUpdateResumeData() {
diff --git a/apps/web/src/components/resume/preview.browser.tsx b/apps/web/src/components/resume/preview.browser.tsx
index 2369b1927..50233d949 100644
--- a/apps/web/src/components/resume/preview.browser.tsx
+++ b/apps/web/src/components/resume/preview.browser.tsx
@@ -4,9 +4,9 @@ import { AnimatePresence, motion } from "motion/react";
 import { useEffect, useRef, useState } from "react";
 import { cn } from "@reactive-resume/utils/style";
 import { useLocalizedResumeDocument } from "@/libs/resume/pdf-document";
+import { useResumeData } from "./builder-resume-draft";
 import { PdfCanvasDocument, PdfCanvasPage } from "./pdf-canvas";
 import { ResumePreviewLoader } from "./preview.shared";
-import { useResumeData } from "./use-resume";
 
 type PreviewPdf = {
 	file: Blob;
diff --git a/apps/web/src/dialogs/resume/index.tsx b/apps/web/src/dialogs/resume/index.tsx
index 935c97397..7b229d67f 100644
--- a/apps/web/src/dialogs/resume/index.tsx
+++ b/apps/web/src/dialogs/resume/index.tsx
@@ -34,7 +34,7 @@ import {
 } from "@reactive-resume/ui/components/input-group";
 import { generateId, generateRandomName, slugify } from "@reactive-resume/utils/string";
 import { ChipInput } from "@/components/input/chip-input";
-import { usePatchResume } from "@/components/resume/use-resume";
+import { usePatchResume } from "@/components/resume/builder-resume-draft";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { authClient } from "@/libs/auth/client";
 import { getResumeErrorMessage } from "@/libs/error-message";
diff --git a/apps/web/src/dialogs/resume/sections/award.tsx b/apps/web/src/dialogs/resume/sections/award.tsx
index 14704cdfd..adb4a7210 100644
--- a/apps/web/src/dialogs/resume/sections/award.tsx
+++ b/apps/web/src/dialogs/resume/sections/award.tsx
@@ -17,7 +17,7 @@ import { Input } from "@reactive-resume/ui/components/input";
 import { Switch } from "@reactive-resume/ui/components/switch";
 import { RichInput } from "@/components/input/rich-input";
 import { URLInput } from "@/components/input/url-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/certification.tsx b/apps/web/src/dialogs/resume/sections/certification.tsx
index a80036dfb..b5729ae03 100644
--- a/apps/web/src/dialogs/resume/sections/certification.tsx
+++ b/apps/web/src/dialogs/resume/sections/certification.tsx
@@ -16,7 +16,7 @@ import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/
 import { Switch } from "@reactive-resume/ui/components/switch";
 import { RichInput } from "@/components/input/rich-input";
 import { URLInput } from "@/components/input/url-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/cover-letter.tsx b/apps/web/src/dialogs/resume/sections/cover-letter.tsx
index 9820ed001..76076c495 100644
--- a/apps/web/src/dialogs/resume/sections/cover-letter.tsx
+++ b/apps/web/src/dialogs/resume/sections/cover-letter.tsx
@@ -14,7 +14,7 @@ import {
 } from "@reactive-resume/ui/components/dialog";
 import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/ui/components/form";
 import { RichInput } from "@/components/input/rich-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/custom.tsx b/apps/web/src/dialogs/resume/sections/custom.tsx
index 0e7a80ff1..2219ed67a 100644
--- a/apps/web/src/dialogs/resume/sections/custom.tsx
+++ b/apps/web/src/dialogs/resume/sections/custom.tsx
@@ -19,7 +19,7 @@ import {
 import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/ui/components/form";
 import { Input } from "@reactive-resume/ui/components/input";
 import { generateId } from "@reactive-resume/utils/string";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { Combobox } from "@/components/ui/combobox";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
diff --git a/apps/web/src/dialogs/resume/sections/education.tsx b/apps/web/src/dialogs/resume/sections/education.tsx
index 547644ca0..139d360f1 100644
--- a/apps/web/src/dialogs/resume/sections/education.tsx
+++ b/apps/web/src/dialogs/resume/sections/education.tsx
@@ -16,7 +16,7 @@ import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/
 import { Switch } from "@reactive-resume/ui/components/switch";
 import { RichInput } from "@/components/input/rich-input";
 import { URLInput } from "@/components/input/url-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/experience.tsx b/apps/web/src/dialogs/resume/sections/experience.tsx
index c9632c71a..2f93da7c6 100644
--- a/apps/web/src/dialogs/resume/sections/experience.tsx
+++ b/apps/web/src/dialogs/resume/sections/experience.tsx
@@ -20,7 +20,7 @@ import { Switch } from "@reactive-resume/ui/components/switch";
 import { generateId } from "@reactive-resume/utils/string";
 import { RichInput } from "@/components/input/rich-input";
 import { URLInput } from "@/components/input/url-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/interest.tsx b/apps/web/src/dialogs/resume/sections/interest.tsx
index de2385622..59e7bbae7 100644
--- a/apps/web/src/dialogs/resume/sections/interest.tsx
+++ b/apps/web/src/dialogs/resume/sections/interest.tsx
@@ -19,7 +19,7 @@ import { cn } from "@reactive-resume/utils/style";
 import { ChipInput } from "@/components/input/chip-input";
 import { ColorPicker } from "@/components/input/color-picker";
 import { IconPicker } from "@/components/input/icon-picker";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/language.tsx b/apps/web/src/dialogs/resume/sections/language.tsx
index 9484d761a..9c5348620 100644
--- a/apps/web/src/dialogs/resume/sections/language.tsx
+++ b/apps/web/src/dialogs/resume/sections/language.tsx
@@ -15,7 +15,7 @@ import {
 } from "@reactive-resume/ui/components/dialog";
 import { FormControl, FormDescription, FormItem, FormLabel, FormMessage } from "@reactive-resume/ui/components/form";
 import { Slider } from "@reactive-resume/ui/components/slider";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/profile.tsx b/apps/web/src/dialogs/resume/sections/profile.tsx
index 43b2f2c54..0fbb5e48d 100644
--- a/apps/web/src/dialogs/resume/sections/profile.tsx
+++ b/apps/web/src/dialogs/resume/sections/profile.tsx
@@ -26,7 +26,7 @@ import { cn } from "@reactive-resume/utils/style";
 import { ColorPicker } from "@/components/input/color-picker";
 import { IconPicker } from "@/components/input/icon-picker";
 import { URLInput } from "@/components/input/url-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/project.tsx b/apps/web/src/dialogs/resume/sections/project.tsx
index b265aacb4..18166de49 100644
--- a/apps/web/src/dialogs/resume/sections/project.tsx
+++ b/apps/web/src/dialogs/resume/sections/project.tsx
@@ -16,7 +16,7 @@ import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/
 import { Switch } from "@reactive-resume/ui/components/switch";
 import { RichInput } from "@/components/input/rich-input";
 import { URLInput } from "@/components/input/url-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/publication.tsx b/apps/web/src/dialogs/resume/sections/publication.tsx
index 554615eed..18b63bea8 100644
--- a/apps/web/src/dialogs/resume/sections/publication.tsx
+++ b/apps/web/src/dialogs/resume/sections/publication.tsx
@@ -16,7 +16,7 @@ import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/
 import { Switch } from "@reactive-resume/ui/components/switch";
 import { RichInput } from "@/components/input/rich-input";
 import { URLInput } from "@/components/input/url-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/reference.tsx b/apps/web/src/dialogs/resume/sections/reference.tsx
index dcd884ab4..52abae340 100644
--- a/apps/web/src/dialogs/resume/sections/reference.tsx
+++ b/apps/web/src/dialogs/resume/sections/reference.tsx
@@ -16,7 +16,7 @@ import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/
 import { Switch } from "@reactive-resume/ui/components/switch";
 import { RichInput } from "@/components/input/rich-input";
 import { URLInput } from "@/components/input/url-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/skill.tsx b/apps/web/src/dialogs/resume/sections/skill.tsx
index 166bbf7a9..11a54f4fb 100644
--- a/apps/web/src/dialogs/resume/sections/skill.tsx
+++ b/apps/web/src/dialogs/resume/sections/skill.tsx
@@ -21,7 +21,7 @@ import { cn } from "@reactive-resume/utils/style";
 import { ChipInput } from "@/components/input/chip-input";
 import { ColorPicker } from "@/components/input/color-picker";
 import { IconPicker } from "@/components/input/icon-picker";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/summary-item.tsx b/apps/web/src/dialogs/resume/sections/summary-item.tsx
index 4c1aa7256..c7e8a28cd 100644
--- a/apps/web/src/dialogs/resume/sections/summary-item.tsx
+++ b/apps/web/src/dialogs/resume/sections/summary-item.tsx
@@ -14,7 +14,7 @@ import {
 } from "@reactive-resume/ui/components/dialog";
 import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/ui/components/form";
 import { RichInput } from "@/components/input/rich-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/dialogs/resume/sections/volunteer.tsx b/apps/web/src/dialogs/resume/sections/volunteer.tsx
index f208737f1..fe4b42e39 100644
--- a/apps/web/src/dialogs/resume/sections/volunteer.tsx
+++ b/apps/web/src/dialogs/resume/sections/volunteer.tsx
@@ -16,7 +16,7 @@ import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/
 import { Switch } from "@reactive-resume/ui/components/switch";
 import { RichInput } from "@/components/input/rich-input";
 import { URLInput } from "@/components/input/url-input";
-import { useUpdateResumeData } from "@/components/resume/use-resume";
+import { useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useFormBlocker } from "@/hooks/use-form-blocker";
 import { makeSectionItem } from "@/libs/resume/make-section-item";
diff --git a/apps/web/src/routes/builder/$resumeId/-components/dock.tsx b/apps/web/src/routes/builder/$resumeId/-components/dock.tsx
index 2977129c4..ff9b4dfc0 100644
--- a/apps/web/src/routes/builder/$resumeId/-components/dock.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-components/dock.tsx
@@ -23,7 +23,7 @@ import { Tooltip, TooltipContent, TooltipTrigger } from "@reactive-resume/ui/com
 import { downloadWithAnchor, generateFilename } from "@reactive-resume/utils/file";
 import { buildDocx } from "@reactive-resume/utils/resume/docx";
 import { cn } from "@reactive-resume/utils/style";
-import { useCurrentResume } from "@/components/resume/use-resume";
+import { useCurrentResume } from "@/components/resume/builder-resume-draft";
 import { authClient } from "@/libs/auth/client";
 import { createResumePdfBlob } from "@/libs/resume/pdf-document";
 
diff --git a/apps/web/src/routes/builder/$resumeId/-components/header.tsx b/apps/web/src/routes/builder/$resumeId/-components/header.tsx
index 326a84d88..442329908 100644
--- a/apps/web/src/routes/builder/$resumeId/-components/header.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-components/header.tsx
@@ -21,7 +21,7 @@ import {
 	DropdownMenuSeparator,
 	DropdownMenuTrigger,
 } from "@reactive-resume/ui/components/dropdown-menu";
-import { useCurrentResume, usePatchResume } from "@/components/resume/use-resume";
+import { useCurrentResume, usePatchResume } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useConfirm } from "@/hooks/use-confirm";
 import { getResumeErrorMessage } from "@/libs/error-message";
diff --git a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/awards.tsx b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/awards.tsx
index 1c574de4d..5f6081564 100644
--- a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/awards.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/awards.tsx
@@ -3,7 +3,7 @@ import type z from "zod";
 import { Trans } from "@lingui/react/macro";
 import { AnimatePresence, Reorder } from "motion/react";
 import { cn } from "@reactive-resume/utils/style";
-import { useCurrentResume, useUpdateResumeData } from "@/components/resume/use-resume";
+import { useCurrentResume, useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { SectionBase } from "../shared/section-base";
 import { SectionAddItemButton, SectionItem } from "../shared/section-item";
 
diff --git a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/basics.tsx b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/basics.tsx
index 75f505e34..f534967ca 100644
--- a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/basics.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/basics.tsx
@@ -4,7 +4,7 @@ import { basicsSchema } from "@reactive-resume/schema/resume/data";
 import { FormControl, FormItem, FormLabel, FormMessage } from "@reactive-resume/ui/components/form";
 import { Input } from "@reactive-resume/ui/components/input";
 import { URLInput } from "@/components/input/url-input";
-import { useCurrentBuilderResumeSelector, useUpdateResumeData } from "@/components/resume/use-resume";
+import { useCurrentBuilderResumeSelector, useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useAppForm } from "@/libs/tanstack-form";
 import { SectionBase } from "../shared/section-base";
 import { CustomFieldsSection } from "./custom-fields";
diff --git a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/certifications.tsx b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/certifications.tsx
index 0ea49b10e..97d80d59f 100644
--- a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/certifications.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/certifications.tsx
@@ -3,7 +3,7 @@ import type z from "zod";
 import { Trans } from "@lingui/react/macro";
 import { AnimatePresence, Reorder } from "motion/react";
 import { cn } from "@reactive-resume/utils/style";
-import { useCurrentResume, useUpdateResumeData } from "@/components/resume/use-resume";
+import { useCurrentResume, useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { SectionBase } from "../shared/section-base";
 import { SectionAddItemButton, SectionItem } from "../shared/section-item";
 
diff --git a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/custom.tsx b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/custom.tsx
index e26f1ebdc..4bf7abf34 100644
--- a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/custom.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/custom.tsx
@@ -32,7 +32,7 @@ import {
 } from "@reactive-resume/ui/components/dropdown-menu";
 import { stripHtml } from "@reactive-resume/utils/string";
 import { cn } from "@reactive-resume/utils/style";
-import { useCurrentResume, useUpdateResumeData } from "@/components/resume/use-resume";
+import { useCurrentResume, useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { useDialogStore } from "@/dialogs/store";
 import { useConfirm } from "@/hooks/use-confirm";
 import { getSectionTitle } from "@/libs/resume/section";
diff --git a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/education.tsx b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/education.tsx
index 325af0294..ab6c11095 100644
--- a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/education.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/education.tsx
@@ -3,7 +3,7 @@ import type z from "zod";
 import { Trans } from "@lingui/react/macro";
 import { AnimatePresence, Reorder } from "motion/react";
 import { cn } from "@reactive-resume/utils/style";
-import { useCurrentResume, useUpdateResumeData } from "@/components/resume/use-resume";
+import { useCurrentResume, useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { SectionBase } from "../shared/section-base";
 import { SectionAddItemButton, SectionItem } from "../shared/section-item";
 
diff --git a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/experience.tsx b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/experience.tsx
index fe63a51fd..52cdf1483 100644
--- a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/experience.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/experience.tsx
@@ -4,7 +4,7 @@ import { plural } from "@lingui/core/macro";
 import { Trans } from "@lingui/react/macro";
 import { AnimatePresence, Reorder } from "motion/react";
 import { cn } from "@reactive-resume/utils/style";
-import { useCurrentResume, useUpdateResumeData } from "@/components/resume/use-resume";
+import { useCurrentResume, useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { SectionBase } from "../shared/section-base";
 import { SectionAddItemButton, SectionItem } from "../shared/section-item";
 
diff --git a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/interests.tsx b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/interests.tsx
index e4d771af2..345a94266 100644
--- a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/interests.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/interests.tsx
@@ -3,7 +3,7 @@ import type z from "zod";
 import { Trans } from "@lingui/react/macro";
 import { AnimatePresence, Reorder } from "motion/react";
 import { cn } from "@reactive-resume/utils/style";
-import { useCurrentResume, useUpdateResumeData } from "@/components/resume/use-resume";
+import { useCurrentResume, useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { SectionBase } from "../shared/section-base";
 import { SectionAddItemButton, SectionItem } from "../shared/section-item";
 
diff --git a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/languages.tsx b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/languages.tsx
index fc9d32913..1ad1f8467 100644
--- a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/languages.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/languages.tsx
@@ -3,7 +3,7 @@ import type z from "zod";
 import { Trans } from "@lingui/react/macro";
 import { AnimatePresence, Reorder } from "motion/react";
 import { cn } from "@reactive-resume/utils/style";
-import { useCurrentResume, useUpdateResumeData } from "@/components/resume/use-resume";
+import { useCurrentResume, useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { SectionBase } from "../shared/section-base";
 import { SectionAddItemButton, SectionItem } from "../shared/section-item";
 
diff --git a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/picture.tsx b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/picture.tsx
index 2b1d02efd..db169b2af 100644
--- a/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/picture.tsx
+++ b/apps/web/src/routes/builder/$resumeId/-sidebar/left/sections/picture.tsx
@@ -17,7 +17,7 @@ import {
 	InputGroupText,
 } from "@reactive-resume/ui/components/input-group";
 import { ColorPicker } from "@/components/input/color-picker";
-import { useCurrentResume, useUpdateResumeData } from "@/components/resume/use-resume";
+import { useCurrentResume, useUpdateResumeData } from "@/components/resume/builder-resume-draft";
 import { getReadableErrorMessage } from "@/libs/error-message";
 import { orpc } from "@/libs/orpc/client";
 import { useAppForm } from "@/libs/tanstack-form";
